package org.apache.commons.lang3.function;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.util.Objects;

@FunctionalInterface
public interface FailablePredicate<T, E extends Throwable> {
  public static final org.apache.commons.lang3.function.FailablePredicate FALSE = t -> false;
  
  public static final org.apache.commons.lang3.function.FailablePredicate TRUE = t -> true;
  
  static <T, E extends Throwable> org.apache.commons.lang3.function.FailablePredicate<T, E> falsePredicate() {
    return FALSE;
  }
  
  static <T, E extends Throwable> org.apache.commons.lang3.function.FailablePredicate<T, E> truePredicate() {
    return TRUE;
  }
  
  default org.apache.commons.lang3.function.FailablePredicate<T, E> and(org.apache.commons.lang3.function.FailablePredicate<? super T, E> other) {
    Objects.requireNonNull(other);
    return t -> (test((T)t) && other.test(t));
  }
  
  default org.apache.commons.lang3.function.FailablePredicate<T, E> negate() {
    return t -> !test((T)t);
  }
  
  default org.apache.commons.lang3.function.FailablePredicate<T, E> or(org.apache.commons.lang3.function.FailablePredicate<? super T, E> other) {
    Objects.requireNonNull(other);
    return t -> (test((T)t) || other.test(t));
  }
  
  boolean test(T paramT) throws E;
}
